﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KonkeDemo
{
    public class AutoTestService
    {
        private ConcurrentDictionary<int, UserControlmodular> ModularDictionary = new ConcurrentDictionary<int, UserControlmodular>();//双向链表

        public AutoTestService() { }

        public AutoTestService(ConcurrentDictionary<int, UserControlmodular> keyValues)
        {
            this.ModularDictionary = keyValues;
            ThreadRun = new Thread[keyValues.Count];
        }
        private bool[] UpdateError;
        private Thread[] ThreadRun;
        protected bool isAllTestThreadsFinished()
        {
            for (int i = 0; i < ThreadRun.Length; i++)
            {
                if (ThreadRun[i] != null
                    && (ThreadRun[i].ThreadState != System.Threading.ThreadState.Aborted
                    && ThreadRun[i].ThreadState != System.Threading.ThreadState.Stopped
                    && ThreadRun[i].ThreadState != System.Threading.ThreadState.Unstarted))
                {

                }
                else
                {
                    if (!UpdateError[i])
                    {
                        ModularDictionary[i + 1].fnUpdate();
                        UpdateError[i] = true;
                    }
                }
            }

            foreach (Thread thread in ThreadRun)
                if (thread != null
                    && (thread.ThreadState != System.Threading.ThreadState.Aborted
                    && thread.ThreadState != System.Threading.ThreadState.Stopped
                    && thread.ThreadState != System.Threading.ThreadState.Unstarted))
                    return false;
            return true;
        }
        public void Run(DeviceInfo deviceinfo)
        {
            try
            {
                UpdateError = new bool[ModularDictionary.Count];
                for (int i = 0; i < ModularDictionary.Count; i++)
                {
                    ModularDictionary[i + 1].Init();

                    object obj = new object();
                    ThreadRun[i] = new Thread(new ParameterizedThreadStart(ModularDictionary[i + 1].Run));
                    ThreadRun[i].Start(obj);
                }
                while (!isAllTestThreadsFinished())
                {
                    System.Threading.Thread.Sleep(100);
                    Application.DoEvents();
                }
                for (int i = 0; i < ModularDictionary.Count; i++)
                {
                    if (!UpdateError[i])
                        ModularDictionary[i + 1].fnUpdate();
                    ModularDictionary[i + 1].Finished();
                }

            }
            catch (Exception exc) { }
        }

        public void Stop() 
        {
            UIDemoProcess autoTest = new UIDemoProcess();
            autoTest.Stop();
        }

        public BaseConfig GetConfig()
        {
            UIDemoProcess autoTest = new UIDemoProcess();
            return autoTest.GetConfig();
        }

        public void SetConfig(BaseConfig baseconfig) 
        {
            UIDemoProcess autoTest = new UIDemoProcess();
            autoTest.SetConfig(baseconfig);

        }
    }
}
