﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KonkeDemo
{
    public partial class FormMain : Form
    {
        ControlChangesWithWindows LoadFormWindows = new ControlChangesWithWindows(); //随窗口改变大小类的实例化
        private ConcurrentDictionary<int, UserControlmodular> ModularDictionary = new ConcurrentDictionary<int, UserControlmodular>();//双向链表
        public FormMain()
        {
            InitializeComponent();
        }
        private void UIfresh() 
        {
            this.WindowState = FormWindowState.Maximized;
            string Layout = Configure.Configure_interface.GetLayout();
            System.Windows.Forms.TableLayoutPanel tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
            tableLayoutPanel1.AutoScroll = true;
            tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
            tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
            tableLayoutPanel1.Name = "tableLayoutPanel1";
            tableLayoutPanel1.Size = new System.Drawing.Size(1663, 571);
            tableLayoutPanel1.TabIndex = 2;
            panel2.Controls.Add(tableLayoutPanel1);

            int iColumnCount = 3;
            int iRowCount = 2;
            iRowCount = int.Parse(Layout.Split(new string[] { "*" }, StringSplitOptions.RemoveEmptyEntries)[0]);
            iColumnCount = int.Parse(Layout.Split(new string[] { "*" }, StringSplitOptions.RemoveEmptyEntries)[1]);
            tableLayoutPanel1.ColumnCount = iColumnCount;
            tableLayoutPanel1.RowCount = iRowCount;
            UserControlmodular usermodular = new UserControlmodular();
            float width = this.Width / iColumnCount;
            if (width >= usermodular.Width)
            {
                for (int i = 0; i < iColumnCount; i++)
                {
                    tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
                }

            }
            else
            {
                for (int i = 0; i < iColumnCount; i++)
                {
                    tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, usermodular.Width));
                }
            }
            for (int k = 0; k < iRowCount; k++)
            {
                tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, usermodular.Height));
            }
            int position = 0;
            for (int i = 0; i < iRowCount; i++)
            {
                for (int j = 0; j < iColumnCount; j++)
                {
                    usermodular = new UserControlmodular();
                    usermodular.BackColor = System.Drawing.Color.Aqua;
                    usermodular.Process = 0;
                    usermodular.iconclusion = 2;
                    usermodular.position = (++position);
                    usermodular.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
                    usermodular.Dock = System.Windows.Forms.DockStyle.Fill;
                    tableLayoutPanel1.Controls.Add(usermodular, j, i);
                    ModularDictionary.TryAdd(position, usermodular);
                }
            }
        }

        private void Form7_Load(object sender, EventArgs e)
        {
            UIfresh();
        }

        private void ucBtnExt3_BtnClick(object sender, EventArgs e)
        {
            Process.Start(AppDomain.CurrentDomain.BaseDirectory.ToString() + "Beacon.chm");
        }

        private void FormMain_Resize(object sender, EventArgs e)
        {
            LoadFormWindows.MethodForResize(this);
        }

        private void FillSN()
        {
            for (int i = 0; i < ModularDictionary.Count; i++)
            {
                if (string.IsNullOrEmpty(ModularDictionary[i + 1].SN))
                {
                    ModularDictionary[i + 1].SN = textEdit1.Text.Trim();
                    textEdit1.Text = "";
                    break;
                }
            }
        }
        private void checkSN(out string ErrorMessage)
        {
            string errorlog = "";
            for (int i = 0; i < ModularDictionary.Count; i++)
            {
                if (string.IsNullOrEmpty(ModularDictionary[i + 1].SN))
                {
                    errorlog = string.Format("工站{0}请输入SN", i + 1);
                    break;
                }
            }
            ErrorMessage = errorlog;
        }

        private void textEdit1_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                FillSN();
        }

        private void ucBtnExt2_BtnClick(object sender, EventArgs e)
        {
            for (int i = 0; i < ModularDictionary.Count; i++)
            {
                ModularDictionary[i + 1].SN = "";
            }
        }

        private void ucBtnExt1_BtnClick(object sender, EventArgs e)
        {
            if (ucBtnExt1.BtnText == "开始")
            {
                string ErrorMessage = "";
                checkSN(out ErrorMessage);
                if (string.IsNullOrEmpty(ErrorMessage))
                {

                    ucBtnExt1.BtnText = "停止";
                    textEdit1.Enabled = false;
                    ucBtnExt2.Enabled = false;
                    ucBtnExt4.Enabled = false;
                    ucBtnExt3.Enabled = false;
                    AutoTestService autoTestService = new AutoTestService(ModularDictionary);
                    autoTestService.Run(null);
                    ucBtnExt1.BtnText = "开始";
                    ucBtnExt2.Enabled = true;
                    ucBtnExt4.Enabled = true;
                    ucBtnExt3.Enabled = true;
                    textEdit1.Enabled = true;

                }
                else 
                {
                    MessageBox.Show(ErrorMessage);
                }
            }
            else if (ucBtnExt1.BtnText == "停止")
            {
                AutoTestService autoTest = new AutoTestService();
                autoTest.Stop();
                ucBtnExt1.BtnText = "开始";
                ucBtnExt2.Enabled = true;
                ucBtnExt4.Enabled = true;
                ucBtnExt3.Enabled = true;
            }
        }

        private void ucBtnExt4_BtnClick(object sender, EventArgs e)
        {
            AutoTestService autoTest = new AutoTestService();
            BaseConfig baseConfig = autoTest.GetConfig();
            FormConfigure configure = new FormConfigure();
            if (configure.ShowDialog(this) == DialogResult.OK)
            {
                autoTest.SetConfig(baseConfig);
            }
        }
    }
}
